!      subroutine load(kfg)
c
c Load Executeble image into Kinetic 3976 ACC (Kinetic 3922+2915 )
c 
c Auther   Koichi Yoshida (RIKEN)
c Date     10-Dec-1997
c
c
      integer*4 ibuf(32768),kbuf(128)
      integer*2 i2buf(65536)
      character filex*50,daytim*18
	include 'on_line$source:common.for'
	include 'camac$library:causer.inc'
	equivalence(ibuf,i2buf)
	data filex(1:1)/' '/

!	integer*2 cam_chan
!	integer*4 errstat(StaMax),iadjbf(3)
!	data kfg/0/
c
c Initializing the Crate Controller
c
	if(caopen(cam_chan,'KPA0:',errstat).ne.1) then
	  call camsg(errstat)
	  call exit
	endif

	write(*,1000)
1000	format('$','ACC address N=')
	read(*,*) nstacc
	if(cactrl(cam_chan,0,CLRINH,errstat).ne.1) then ! Clear Inhibit
	  call camsg(errstat)
	endif
	if(cactrl(cam_chan,0,INIT,errstat).ne.1) then ! Do Z  
	  call camsg(errstat)
	endif

c
c open file (68030 exec image file) and read
c
	write(6,1001)
1001	format('0* Kinetic 3976 ACC * Loader Program V1.0 10-Dec-97'/)        
	IF(KFG.EQ.1.AND.FILEX(1:1).NE.' ') GOTO 6
5	write(6,1002)
1002	format('$Enter executable image file name > ')
	read(5,'(A50)') filex
c
6	open(unit=1,file=filex,defaultfile='.exe',
     1      status='old',form='unformatted',err=5)

	do j=1,256
	  read(1,iostat=iost,end=10,err=20) kbuf
	  do k=1,128
	    ibuf((j-1)*128+k)=kbuf(k)
	  enddo
	enddo
	goto 100
10	j=j-1
	kw=j*256
	kb=j*512
	write(6,*)'EOF detected, ',j,' blocks (',kb,' byte) has been read'
	goto 100
20	write(6,*) 'Error in read  iost=',iost
	stop
100	close(unit=1) 

c
c Print some task imformation
c
	ibas=ibuf(1)
	itra=ibuf(2) 
	isize=ibuf(3)
!	write(6,2000) i2buf(8),i2buf(7),isize,ibas,itra
! 2000 format('0Task address limit (hex)    =',2O8/
!     *       ' Task image size  (decimal)  =',I8,' byte'/
!     *       ' Task base address (hex)     =',z8/,
!     *       ' Task transfer address(hex)  =',z8/)
	write(6,2000) isize,ibas,itra
2000	format('0Task image size  (decimal)  =',I8,' byte'/
	1      ' Task base address (hex)     =',z8/,
	2      ' Task transfer address(hex)  =',z8/)
c
c J11 Task control block definition 
c
c 1000 loader id code (21845 dec)
c 1002 loader version number
c 1004 Start address
c 1006 base  address
c 1010 program size
c 1012 program limit
c
c 1020-1077 File name (48 byte)
c 1100-1120 loaded date and time
c
!      i2buf(769)=21845		! loader id code
!      i2buf(770)=1		! loader version
!      i2buf(771)=itra		! image start address
!      i2buf(772)=ibas		! image base address
!      i2buf(773)=i2buf(6)	! program size (byte)
!      i2buf(774)=i2buf(7)	! program size (byte)
!      i2buf(775)=0		! reserved
!      i2buf(776)=0		! reserved
!      call date(daytim(1:9))
!      call time(daytim(11:18))
!      daytim(10:10)=' '
!      read(filex(1:48),'(24A2)')  (i2buf(i),i=777,800)! image file name
!      read(daytim(1:18),'(9A2)') (i2buf(i),i=801,809)!  image file name
   
        if(cactrl(cam_chan,0,CLRINH,errstat).ne.1) then
          call camsg(errstat)
        endif
c
c Reset 3976 ACC
c
	call cam16(cam_chan,0,nstacc,0,9,iadd,errstat)	! Clear Module
c
c Wait Self-test done
c
	call cam16(cam_chan,0,nstacc,15,8,iadd,errstat)	! test LAM
	do while(errstat(QXSUM) .ne. 0)		! check Q and if not, wait
	  call cam16(cam_chan,0,nstacc,15,8,iadd,errstat)
	end do
	wait = lib$wait(1.)	! wait a little
c
c set 3976 memory address counter
c
	call cam24(cam_chan,0,nstacc,0,17,ibas,errstat)
	write(6,1020)
1020	format(1h ,/ ' Now sending data to 3976 ACC ...')        
c
c write the 3976 memory
c
	call cab16(cam_chan,0,nstacc,0,16,QRPT,i2buf(257),kw-256,errstat)
	if(errstat(tc) .ne. kw-256) then
	  write(*,*) 'Transfer abnomaly ended at',errstat(tc),kw-256
	  goto 200
	endif
c
c Read Buffer address of Data taking task by K. Yoshida 12/4/92
c
	mbxacc(1)=ibas				! IDR Instruction reg.
	mbxacc(2)=ibas+4			! RSR Command Response
	mbxacc(3)=ibas+8			! STR Status reg.
	mbxacc(4)=ibas+12			! VIR Buffer Inf.

	ibpt=257+12				! BPT address
	ibpt1=i2buf(ibpt+1)			! BPTP low address
	if(ibpt1 .lt. 0) ibpt1=ibpt1+65536
	ibpt1=i2buf(ibpt)*65536+ibpt1		! BPTP address
	iadjbf(1)=ibpt1+16			! BCBF adress

	ibpt1=(ibpt1+24-ibas)/2+257
	ibfadd=i2buf(ibpt1+1)			! BCB1 low address
	if(ibfadd .lt. 0) ibfadd=ibfadd+65536
	ibfadd=i2buf(ibpt1)*65536+ibfadd	! BCB1 address
	ibfadd=(ibfadd-ibas)/2+257
	iadjbf(2)=i2buf(ibfadd+1)		! Buffer1 low Address
	if(iadjbf(2) .lt. 0) iadjbf(2)=iadjbf(2)+65536
	iadjbf(2)=i2buf(ibfadd)*65536+iadjbf(2)	! Buffer1 Address

	ibfadd=i2buf(ibpt1+3)		 	! BCB2 address
	if(ibfadd .lt. 0) ibfadd=ibfadd+65536
	ibfadd=i2buf(ibpt1+2)*65536+ibfadd 	! BCB2 address
	ibfadd=(ibfadd-ibas)/2+257
	iadjbf(3)=i2buf(ibfadd+1)		! Buffer2 low Address
	if(iadjbf(3) .lt. 0) iadjbf(3)=iadjbf(3)+65536
	iadjbf(3)=i2buf(ibfadd)*65536+iadjbf(3)	! Buffer2 Address
	if(ibpt1 .lt. 0) ibpt1=ibpt1+65536
c
c set start address
c
	call cam24(cam_chan,0,nstacc,0,17,itra,errstat)
C
C Start 3976 ACC
C
	call cam16(cam_chan,0,nstacc,0,25,iadd,errstat)

	kt=(kw-512)*2
	write(6,4000) kt,itra,(mbxacc(k),k=1,4),(iadjbf(k),k=1,3)
4000	format(/' Transfer data =',i6,' byte',/,
	1	' Start address =',z8,/,
	1	' Mbx address =',4z8,/,
	2	' Buffer address =',3z8)

200	continue
!      return
	stop
	end
